﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Reflection;
using WidgetLib;

namespace DynamicAssemblyLoading
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
        }

        void wc_DownloadProgressChanged(object sender, DownloadProgressChangedEventArgs e)
        {
            rcProgress.Width = (double)e.ProgressPercentage/100.0 * layoutWidget.ActualWidth;
            tbFileSize.Text = string.Format("{0}byte/{1}byte", e.BytesReceived, e.TotalBytesToReceive);
        }

        void wc_OpenReadCompleted(object sender, OpenReadCompletedEventArgs e)
        {
            if (e.Cancelled == true || e.Error != null)
                return;

            AssemblyPart part = new AssemblyPart();
            Assembly assembly = part.Load(e.Result);

            //MyWidget widget = new MyWidget();
            //layoutWidgetHolder.Children.Clear();
            //layoutWidgetHolder.Children.Add(widget);
            AddWidget();
        }

        [System.Runtime.CompilerServices.MethodImpl
            (System.Runtime.CompilerServices.MethodImplOptions.NoInlining)]
        private void AddWidget()
        {
            MyWidget widget = new MyWidget();
            layoutWidgetHolder.Children.Clear();
            layoutWidgetHolder.Children.Add(widget);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            WebClient wc = new WebClient();
            wc.OpenReadCompleted += new OpenReadCompletedEventHandler(wc_OpenReadCompleted);
            wc.DownloadProgressChanged += new DownloadProgressChangedEventHandler(wc_DownloadProgressChanged);
            wc.OpenReadAsync(new Uri("WidgetLib.dll", UriKind.Relative));
        }
    }
}
